#include <BluetoothSerial.h>
#if !defined(CONFIG_BT_ENABLED) || !defined(CONFIG_BLUEDROID_ENABLED)
#error Bluetooth is not enabled! Please run `make menuconfig` to and enable it
#endif
BluetoothSerial SerialBT;

#include "defin.h"
#include "Wire.h"
#include "step_motor.h" // Обслуживание шаговых моторов
#include "fromsmart.h" // Обслуживание шаговых моторов

Adafruit_BNO055 bno = Adafruit_BNO055(55, 0x29);

//
// WARNING!!! Make sure that you have either selected ESP32 Wrover Module,
//            or another board which has PSRAM enabled
//


void setup() {


  Serial.begin(115200);
  Serial.println();

  SerialBT.begin("BARSIK"); //Имя робота в BT

  if (!bno.begin())
  {
    /* There was a problem detecting the BNO055 ... check your connections */
    Serial.print("Ooops, no BNO055 detected ... Check your wiring or I2C ADDR!");
    while (1);
  }

  setup_motor_system();
  Serial.println("Do");
  motor_off();
  delay(1000);
  /* Display the current temperature */
  int8_t temp = bno.getTemp();
  Serial.print("Current Temperature: ");
  Serial.print(temp);
  Serial.println(" C");
  Serial.println("");

  bno.setExtCrystalUse(false); // Не используем внешний кварц
  //bno.setExtCrystalUse(true); // используем внешний кварц
  Serial.println("Calibration status values: 0=uncalibrated, 3=fully calibrated");


  t0 = micros() - 5000;
  t2 = micros();
  delay(1000);
  Axel_Gravity = bno.getVector(Adafruit_BNO055::VECTOR_GRAVITY);
  GyXsum0 = atan2(Axel_Gravity.y(), Axel_Gravity.z());
  GyXsum0  = 0;

  //timerAlarmEnable(timerL);
  Speed = 0;

}

void loop()
{

  //  bno.getEvent(&event);
  //  Gyro = bno.getVector(Adafruit_BNO055::VECTOR_GYROSCOPE);
  //  Serial.println("============Euler =====================");
  //  Serial.print("event.orientation.x="); Serial.print(event.orientation.x);
  //  Serial.print("  event.orientation.y="); Serial.print(event.orientation.y);
  //  Serial.print("  event.orientation.z="); Serial.println(event.orientation.z);
  //  Serial.println("============ Gyro =====================");
  //  Serial.print("Gyro.x()="); Serial.print(Gyro.x());
  //  Serial.print("  Gyro.y()="); Serial.print(Gyro.y());
  //  Serial.print("  Gyro.z()="); Serial.println(Gyro.z());
  //
  //  motor_on();
  //  SpeedL = 100;
  //  SpeedR = 100;
  //  SetSpeed();
  //
  //  delay(300);
  //  return;

  uint64_t micros_;
  micros_ = micros();
  if (micros_ < t2) return;//Если период < t2 анализ. прошло 5000 если да, измеряем угловую скорость.
  BT_input();
  //Опрос гироприбора:
  bno.getEvent(&event); // Берем сразу углы Эйлера
  if (flag_crash)
  {
    if (abs(event.orientation.y) < 5)//???
    {
      Speed = 0;
      Move = 0;
      AcYsum = 0;
      OldSpeed = 0;
      flag_crash = false;
      t_period = 5000;
      t0 = micros_;
      t2 = t0 + t_period;
      SetSpeed();
      motor_on();
      return;
      
    }
  }
  dt = micros() - t0; // Длительность предыдущего периода регулирования.
  t0 += dt; //Точка начала нового периода регулирования.
  liamda_time = 0; // Обнуляем приращение для длительных периодов (они у нас при минимальной скорости)
  static int i = 0; // для торможения вывода
  double Dt = double(dt) * 0.000001;
  // Нужно поймать угол, рядом с которым угловая скорость колеблется в районе нуля.
  OldAcYsum = AcYsum;
  AcYsum = (double)event.orientation.y * DEG_TO_RAD;
  Gyro = bno.getVector(Adafruit_BNO055::VECTOR_GYROSCOPE);

  XL = counter_stepL; counter_stepL = 0;
  XR = counter_stepR; counter_stepR = 0;
  XSpeedL =  SpeedL;// double(XL) / Dt; //Реальная скорость колес L //SpeedL;//
  XSpeedR =  SpeedR;//double(XR) / Dt; //Реальная скорость колес R //SpeedR;//
  XSpeed =  (XSpeedL + XSpeedR) * 0.5; //Реальная скорость колес

  Move += Dt * (XSpeed - OldCommandSpeed); //Это как раз пройденный путь

  //SpeedR = constrain(Move, -10000.0, +10000.0);
  if ((abs(XSpeed - OldCommandSpeed) + maxSpeed * 0.1) > maxSpeed) //Если вошли в критичный режим
  {
    XSpeed = 0;
    OldCommandSpeed = 0;
    CommandSpeed = 0;
    Move = 0;
    SpeedL = 0;
    SpeedR = 0;
    OldXSpeedL = SpeedL;
    OldXSpeedR  = SpeedR;
    Speed = 0;
    t_period = 500000;
    t2 = t0 + t_period;
    SetSpeed();
    Turn =0; TurnOld=0;
    time_start_move = millis()+1000; //Секунда на стабилизацию
    return;
  }
  else
  {
    dSpeedL = (XSpeedL - OldXSpeedL) / Dt;
    dSpeedR = (XSpeedR - OldXSpeedR) / Dt;
    OldXSpeed = XSpeed;
    double DT = CommandSpeed - OldCommandSpeed;
    DT = constrain(DT, -20, 20);
    OldCommandSpeed += DT;
    //Speed = (AcYsum) *  5.0 * 800.0 * 20.0 / (2 * PI * 40.0) - 12.0  * Gyro.y() * DEG_TO_RAD * 800.0 / (40.0 * 2 * PI) + XSpeed + Move * 0.1 + (XSpeed - OldCommandSpeed) * 0.056; // - dSpeed * 0.002; //
    Speed = (AcYsum) *  6.0 * 800.0 * 20.0 / (2 * PI * 40.0) - 20.0  * Gyro.y() * DEG_TO_RAD * 800.0 / (40.0 * 2 * PI) + XSpeed + Move * 0.13 + (XSpeed - OldCommandSpeed) * 0.056; // - dSpeed * 0.002; //
    OldXSpeedL = SpeedL;
    OldXSpeedR  = SpeedR;
    DT = Turn - TurnOld;
    DT = constrain(DT, -20, 20);
    TurnOld += DT;
    SpeedL = Speed - dSpeedL * 0.002 + TurnOld;
    SpeedR = Speed - dSpeedR * 0.002 - TurnOld;
    Speed = (SpeedL + SpeedR) * 0.5;
    if (fabs(Speed) < 10.0) //Стабильное значение интегрального звена
    {
      MoveStab = MoveStab * 0.99 + 0.01 * Move;
    }
  }
  // OldCommandSpeed = CommandSpeed; //
  //Speed - это число шагов в секунду
  //Нужно именять длительность периода подстраиваясь под шаг, чтобы был сделан хотябы один шаг.

  double RealSpeed;
  if (fabs(SpeedL) < 10.0)
  {
    SpeedL = 0;
  }
  else
  {
    SpeedL = constrain(SpeedL, -maxSpeed, maxSpeed);
  }
  if (fabs(SpeedR) < 10.0)
  {
    SpeedR = 0;
  }
  else
  {
    SpeedR = constrain(SpeedR, -maxSpeed, maxSpeed);
  }

  RealSpeed = (SpeedR + SpeedL) * 0.5;

  t_period = 5000;
  t2 = t0 + t_period;
  //  if ((abs(event.orientation.z) < 45) && (abs(event.orientation.y) < 45))
  SetSpeed();
  //  else
  //  {
  //    motor_off();
  //    Speed = 0;
  //    Move = 0;
  //    AcYsum = 0;
  //    OldSpeed = 0;
  //    flag_crash = true;
  //  }

  if (i > 20)
  {
    i = 0;
  }
  i++;

}

bool stay_from_off() //Встать из положения сидя/лежа
{

}
